<template>
	<b-container class="w-50 full-height">
		<b-row class="h-100 align-items-center">
			<b-col>
				<b-card header="Login" header-tag="h3">
					<b-form @submit.prevent="login">
						<b-form-group
							id="username-grp"
							description="Your username without &quot;@&quot;"
							label="Username"
							label-for="username">
							<b-form-input
								required
								id="username"
								autocomplete="username"
								v-model="credentials.username"
								:disabled="busy"/>
						</b-form-group>
						<b-form-group
							id="password-grp"
							label="Password"
							label-for="password">
							<b-form-input
								required
								id="password"
								v-model="credentials.password"
								autocomplete="current-password"
								type="password"
								:disabled="busy"/>
						</b-form-group>
						<transition name="fade">
							<b-spinner v-if="busy" class="mt-1" variant="primary" label="Loading..."/>
						</transition>
						<b-button variant="outline-custom-dark" type="submit" class="float-right" :disabled="busy">
							Log in!
						</b-button>
					</b-form>
				</b-card>
			</b-col>
		</b-row>
	</b-container>
</template>

<script>
import {errorJsonToToast,} from '@/utils';

export default {
	name: 'Login',
	data() {
		return {
			credentials: {},
			busy: false,
		};
	},
	methods: {
		login() {
			this.busy = true;
			const data = this.credentials;
			console.debug('Executing login!', data);
			this.$http.post('/login/', data, {
				headers: {
					'Authorization': undefined, // Override default if not logged in
				},
			})
				.then(r => {
					this.busy = false;
					const data = r.data;
					this.$store.commit('persistent/setAuthToken', data.token);
					this.$router.replace('/mailbox');
				})
				.catch(e => {
					this.busy = false;
					console.error('Failed to log in', e);
					this.$bvToast.toast(errorJsonToToast(this, e), {
						title: 'Failed to log in',
						variant: 'danger',
					});
				});
		},
	},
};
</script>

<style scoped>
/*noinspection CssUnusedSymbol*/
>>> .form-control {
	transition: background-color 0.3s;
}
</style>
